Loading...
Searching...
No Matches
Sip_path

## Macros

#define | sip_path(sip)
| Access a SIP Path header structure sip_path_t from sip_t.
#define | SIP_PATH_INIT()
| Initializer for structure sip_path_t.
#define | SIPTAG_PATH(x)
| Tag list item for pointer to a Path header structure sip_path_t.
#define | SIPTAG_PATH_REF(x)
| Tag list item for reference to a Path header pointer.
#define | SIPTAG_PATH_STR(s)
| Tag list item for string with Path header value.
#define | SIPTAG_PATH_STR_REF(x)
| Tag list item for reference to a Path header string.

## Typedefs

typedef struct sip_route_s | sip_path_t
| @

## Functions

issize_t | sip_path_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Path header.
issize_t | sip_path_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Path header.
sip_path_t * | sip_path_init (sip_path_t x[1])
| Initialize a structure sip_path_t.
int | sip_is_path (sip_header_t const *header)
| Test if header object is instance of sip_path_t.
sip_path_t * | sip_path_dup (su_home_t *home, sip_path_t const *hdr))
| Duplicate a list of Path header header structures sip_path_t.
sip_path_t * | sip_path_copy (su_home_t *home, sip_path_t const *hdr))
| Copy a list of Path header header structures sip_path_t.
sip_path_t * | sip_path_make (su_home_t *home, char const *s))
| Make a Path header structure sip_path_t.
sip_path_t * | sip_path_format (su_home_t *home, char const *fmt,...)))
| Make a Path header from formatting result.

## Variables

msg_hclass_t | sip_path_class []
| Header class for Path header.
tag_typedef_t | siptag_path
| Tag for Path header object.
tag_typedef_t | siptag_path_str
| Tag for string with Path header value.

## Detailed Description

## Macro Definition Documentation

## SIP_PATH_INIT

#define SIP_PATH_INIT | ( |  | ) |

Initializer for structure sip_path_t.

A static sip_path_t structure for Path header must be initialized with the SIP_PATH_INIT() macro. For instance,

sip_path_t sip_path = SIP_PATH_INIT;
sip_path_t
struct sip_route_s sip_path_t
@
Definition sip.h:211
sip_path
#define sip_path(sip)
Access a SIP Path header structure sip_path_t from sip_t.
Definition sip_protos.h:12507
SIP_PATH_INIT
#define SIP_PATH_INIT()
Initializer for structure sip_path_t.
Definition sip_protos.h:12524

## SIPTAG_PATH

#define SIPTAG_PATH | ( |  | x | ) |

Tag list item for pointer to a Path header structure sip_path_t.

The SIPTAG_PATH() macro is used to include a tag item with a pointer to a sip_path_t structure in a tag list.

Parameters

  x | pointer to a sip_path_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_PATH_REF().

## SIPTAG_PATH_STR

#define SIPTAG_PATH_STR | ( |  | s | ) |

Tag list item for string with Path header value.

The SIPTAG_PATH_STR() macro is used to include a tag item with a string containing value of a sip_path_t header in a tag list.

Parameters

  s | pointer to a string containing Path header value, or NULL.

The string in SIPTAG_PATH_STR() can be converted to a sip_path_t header structure by giving the string s has second argument to function sip_path_make().

The corresponding tag taking reference parameter is SIPTAG_PATH_STR_REF().

## Typedef Documentation

## sip_path_t

typedef struct sip_route_s sip_path_t

@

The Path header field is a SIP extension header field (RFC 3327) with syntax very similar to the Record-Route header field. It is used in conjunction with SIP REGISTER requests and with 200 class messages in response to REGISTER (REGISTER responses).

Path = "Path" HCOLON path-value *(COMMA path-value)
path-value = name-addr *( SEMI rr-param )

The parsed Path header is stored in sip_path_t structure.

The structure sip_path_t contains representation of SIP Path header.

The sip_path_t is defined as follows:

typedef struct sip_route_s {
sip_common_t r_common[1]; // Common fragment info
sip_path_t *r_next; // Link to next @Path
char const *r_display; // Display name
url_t r_url[1]; // @Path URL
msg_param_t const *r_params; // List of parameters
} sip_path_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_route_s
Structure for Route and Record-Route header fields.
Definition sip.h:681
sip_route_s::r_display
char const * r_display
Display name.
Definition sip.h:684
sip_route_s::r_next
sip_route_t * r_next
Link to next.
Definition sip.h:683
sip_route_s::r_url
url_t r_url[1]
Route URL
Definition sip.h:685
sip_route_s::r_common
sip_common_t r_common[1]
Common fragment info.
Definition sip.h:682
sip_route_s::r_params
msg_param_t const * r_params
List of route parameters.
Definition sip.h:686
url_t

## Function Documentation

## sip_is_path()

int sip_is_path | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_path_t.

Check if the header class is an instance of Path header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header path
  0 | (false) otherwise

## sip_path_copy()

sip_path_t * sip_path_copy | ( | su_home_t * | home,
|  | sip_path_t const * | hdr )

inline

Copy a list of Path header header structures sip_path_t.

The function sip_path_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  path = sip_path_copy(home, sip->sip_path);
  sip_path_copy
  sip_path_t * sip_path_copy(su_home_t *home, sip_path_t const *hdr))
  Copy a list of Path header header structures sip_path_t.
  Definition sip_protos.h:12654

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_path_dup()

sip_path_t * sip_path_dup | ( | su_home_t * | home,
|  | sip_path_t const * | hdr )

inline

Duplicate a list of Path header header structures sip_path_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  path = sip_path_dup(home, sip->sip_path);
  sip_path_dup
  sip_path_t * sip_path_dup(su_home_t *home, sip_path_t const *hdr))
  Duplicate a list of Path header header structures sip_path_t.
  Definition sip_protos.h:12611

Returns
  A pointer to the newly duplicated sip_path_t header structure, or NULL upon an error.

## sip_path_format()

sip_path_t * sip_path_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Path header from formatting result.

Make a new sip_path_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_path_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_path_init()

sip_path_t * sip_path_init | ( | sip_path_t | x[1] | ) |

inline

Initialize a structure sip_path_t.

An sip_path_t structure for Path header can be initialized with the sip_path_init() function/macro. For instance,

sip_path_t sip_path;
sip_path_init(&sip_path);
sip_path_init
sip_path_t * sip_path_init(sip_path_t x[1])
Initialize a structure sip_path_t.
Definition sip_protos.h:12542

## sip_path_make()

sip_path_t * sip_path_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Path header structure sip_path_t.

The function sip_path_make() makes a new sip_path_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_path_t header structure, or NULL upon an error.

## Variable Documentation

## sip_path_class

msg_hclass_t sip_path_class[]

extern

Header class for Path header.

The header class sip_path_class defines how a SIP Path header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_path_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.